package lab13_solutions;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Iterator;


public class TestHashing {


	  /**
	    Load phone information from a text file into a hash table.
	    @param ht the hash table
	  */
	  public static void loadRecords(Hashtable<String, Integer> ht)
	  {
	    try
	    {
	      FileReader reader = new FileReader("phoneinfo.txt");
	      BufferedReader inFile = new BufferedReader(reader);

	      /* Each iteration of this loop reads phone information for
	         one person from inFile and inserts <Name - Phone> into
	         the hash table ht. */

	      while (true)
	      {
	        String inputLine = inFile.readLine();

	        if (inputLine == null) // end of file
	          break;

		    int i = 0;
		    while (i < inputLine.length() && !Character.isDigit(inputLine.charAt(i)) )
		      i++;

		    String nameInfo = inputLine.substring(0,i-1);
		    int numInfo = Integer.parseInt(inputLine.substring(i));
		    
	        Integer res = ht.put(nameInfo, numInfo);
	        
	        if (res != null ) {
	        	System.out.println("Record replaced");
	        }
	      }

	      reader.close();
	    }

	    catch(IOException e)
	    {
	      System.out.println("Input/output error " + e);
	      System.out.println("Probable cause: incorrect file format.\n");
	    }
	  }


	  
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Hashtable<String, Integer> phonebook = new Hashtable<String, Integer>();


	    System.out.println("\nLoading records from a text file ...");
	    loadRecords(phonebook);
	    System.out.println(phonebook); //print the phone book
	    
	    System.out.println("Searching phone for tom ... : "+phonebook.get("tom"));
	    
	    System.out.println("Searching phone for andreas ... : "+phonebook.get("andreas"));
	    if (phonebook.put("andreas", 1234) == null) {
	    	System.out.println("Inserted record andreas - 1234");
	    }
	    System.out.println("Searching phone for andreas ... : "+phonebook.get("andreas"));
	    
	    System.out.println("\nIterate and print all key-value pairs:");
	    for (String name : phonebook.keySet()) {
	        System.out.println(name + "\t:\t" + phonebook.get(name));
	    }
	    
	    //using an iterator
	    System.out.println("\nIterate and print all key-value pairs using an iterator:");
	    for( Iterator<String> iter=phonebook.keySet().iterator(); iter.hasNext(); ) {
	        String name = iter.next();
	        Integer phone = phonebook.get( name );
	        System.out.println(name + "\t:\t" + phone);
	        
	    }
	}

}
